config/routes.rb
Rails.application.routes.draw do
  resources :lessons
  resources :classrooms
  resources :users, except: [:new, :create]

  root 'home#index'
  
  scope "auth" do
    devise_for :users
  end

  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
end

app/models/ability.rb
# frozen_string_literal: true

# CanCanCan authorization class
class Ability
  include CanCan::Ability

  def initialize(user)

    alias_action :edit, :update, :to => :modify
    # what everyone cannot?
    cannot :manage, :all
    
    # what everyone can?
    can :read, HomeController

    # since here, only users
    return unless user.present?

    can :edit, User, id: user.id

    case user.role
    when 'lead'
      # what a common user can?

    when 'admin'
      # what admin can?
      can :manage, :all

      can :access, :rails_admin   # grant access to rails_admin
      can :read, :dashboard       # grant access to the dashboard

      # what admin cant?
      cannot :destroy, User, id: user.id
    end
    #
    # The first argument to `can` is the action you are giving the user
    # permission to do.
    # If you pass :manage it will apply to every action. Other common actions
    # here are :read, :create, :update and :destroy.
    #
    # The second argument is the resource the user can perform the action on.
    # If you pass :all it will apply to every resource. Otherwise pass a Ruby
    # class of the resource.
    #
    # The third argument is an optional hash of conditions to further filter the
    # objects.
    # For example, here the user can only update published articles.
    #
    #   can :update, Article, :published => true
    #
    # See the wiki for details:
    # https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
  end
end

app/models/application_record.rb
# frozen_string_literal: true

# Basic application record
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/user.rb
# frozen_string_literal: true

# User model
class User < ApplicationRecord
  extend Enumerize
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable,
         :confirmable, :lockable, :trackable

  enumerize :role, in: %i[lead manager admin], default: :lead, predicates: true

  validates :name, :email, :role, presence: true
end

app/controllers/application_controller.rb
require 'application_responder'

# frozen_string_literal: true

# Application controller
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  self.responder = ApplicationResponder
  respond_to :html

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name])
  end
end

app/controllers/base_controller.rb
# frozen_string_literal: true

# Base controller
class BaseController < ApplicationController
  before_action :authenticate_user!
end

app/controllers/home_controller.rb
# frozen_string_literal: true

# Home Controller
class HomeController < ApplicationController
  # cancancan authorization
  load_and_authorize_resource class: HomeController
end

app/controllers/users_controller.rb
# frozen_string_literal: true

# Home Controller
class UsersController < BaseController
  # cancancan authorization
  load_and_authorize_resource

  before_action :set_user, only: %i[show edit update destroy]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
    respond_with @user
  end

  # GET /users/1/edit
  def edit; end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    @user.update(user_params)
    respond_with @user
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_with @user
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_user
    @user = User.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def user_params
    params.require(:user).permit(:name, :role, :email)
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

# Helper to application context
module ApplicationHelper
end

app/helpers/home_helper.rb
# frozen_string_literal: true

# Home Helper
module HomeHelper
end

app/views/home/index.html.slim
h1
  | HOME 

app/views/layouts/application.html.slim
doctype html
html lang="en"
  head
    meta charset="utf-8"
    meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1"
    meta name="viewport" content="width=device-width, initial-scale=1.0"
    title= content_for?(:title) ? yield(:title) : t('app.name')
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_pack_tag 'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'
    /! Le HTML5 shim, for IE6-8 support of HTML elements
    /[if lt IE 9]
      = javascript_include_tag "//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.2/html5shiv.min.js"

  body
    = render partial: "shared/navbar"

    .container.pt-3
      - if notice
        .alert.alert-primary role="alert"
          = notice
      - if alert
        .alert.alert-danger role="alert"    
          = alert
      .row
        .col
          = yield
footer
  span &copy; = "#{t('app.name')} #{Date.today.year}"

app/views/shared/_error_messages.html.slim
- if model.errors.any?
  .alert.alert-danger role="alert"
    - model.errors.full_messages.each do |message|
      div= message

app/views/shared/_navbar.html.slim
nav.navbar.navbar-expand-lg.navbar-dark.bg-primary
  a.navbar-brand href="/" = t('app.name')
  button.navbar-toggler type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation"
    span.navbar-toggler-icon

  .collapse.navbar-collapse id="navbarSupportedContent"
    .navbar-nav
      .nav-item= link_to t('.home'), root_path, class: 'nav-link'
      / - if can? :read, User #example of link
        .nav-item
          = link_to User.model_name.human(count: 2).titleize, users_path, class: 'dropdown-item'
    
    .navbar-nav.ml-auto
      - if user_signed_in?
        .nav-item.dropdown
          a.nav-link.dropdown-toggle id="navbarDropdown" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false" 
            = current_user.name
          .dropdown-menu.dropdown-menu-right aria-labelledby="navbarDropdown"
            .dropdown-item
              = current_user.email
            .dropdown-item
              = current_user.role  
            .dropdown-divider
            = link_to t('.logout'), destroy_user_session_path, method: :delete, class: 'dropdown-item'
            - if can? :manage, User
              .dropdown-divider
              = link_to User.model_name.human(count: 2).titleize, users_path, class: 'dropdown-item'
      - else
        .nav-item= link_to t('.login'), new_user_session_path, class: 'nav-link'
      
      

app/views/users/_form.html.slim
= form_for @user, html: { class: "form form-horizontal user" } do |f|
  = render partial: "shared/error_messages", :locals => { model: @user} 
  .row
    .col
      .form-group
        = f.label :name, :class => 'control-label'
        = f.text_field :name, :class => 'form-control input-md'
    .col
      .form-group
        = f.label :role, :class => 'control-label'
        = f.select :role, User.role.options, { :include_blank => t('helpers.select.prompt') }, { :class => 'form-control' } 
    
  .form-group
    = f.label :email, :class => 'control-label'
    = f.email_field :email, :class => 'form-control'
  
  .btn-group role="group"
    = f.submit nil, :class => 'btn btn-primary'
    = link_to t('.cancel', :default => t("helpers.links.cancel")), users_path, :class => 'btn btn-secondary'

app/views/users/edit.html.slim
- model_class = User
.page-header
  h1=t '.title', :default => [:'helpers.titles.edit', 'Edit %{model}'], :model => model_class.model_name.human.titleize
= render :partial => "form"

app/views/users/index.html.slim
- model_class = User
.page-header
  h1=t '.title', :default => model_class.model_name.human.pluralize.titleize
table.table.table-striped
  thead
    tr
      th= model_class.human_attribute_name(:id)
      th= model_class.human_attribute_name(:name)
      th= model_class.human_attribute_name(:role)
      th= model_class.human_attribute_name(:email)
      th= t '.actions', :default => t("helpers.actions")
  tbody
    - @users.each do |user|
      tr
        td= link_to user.id, user_path(user)
        td= user.name
        td= user.role
        td= user.email
        td
          .btn-group role="group"
            - if can? :read, User
              = link_to t('.show', :default => t("helpers.links.show")), user_path(user), :class => 'btn btn-light'
            - if can? :manage, user
              = link_to t('.edit', :default => t("helpers.links.edit")), edit_user_path(user), :class => 'btn btn-secondary'
            - if can? :destroy, user  
              = link_to t('.destroy', :default => t("helpers.links.destroy")), user_path(user), :method => :delete, :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) }, :class => 'btn btn-danger'

app/views/users/show.html.slim
- model_class = User
.page-header
  h1=t '.title', :default => model_class.model_name.human.titleize

.row
  .col
    strong= model_class.human_attribute_name(:name) + ': '
    = @user.name
  .col
    strong= model_class.human_attribute_name(:email) + ': '
    = @user.email
.row
  .col
    strong= model_class.human_attribute_name(:role) + ': '
    = @user.role  

  - @user.classrooms.any?
    .col
      strong= model_class.human_attribute_name(:classrooms) + ': '
      = @user.classrooms.map(&:name).join(", ")

.row.mt-4
  .col
    .btn-group role="group"
      - if can? :read, model_class
        = link_to t('.back', :default => t("helpers.links.back")), users_path, :class => 'btn btn-secondary'
      - if can? :manage, @user
        = link_to t('.edit', :default => t("helpers.links.edit")), edit_user_path(@user), :class => 'btn btn-secondary'
      - if can? :destroy, @user  
        = link_to t('.destroy', :default => t("helpers.links.destroy")), user_path(@user), :method => "delete", :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) }, :class => 'btn btn-danger'